#
# REMARK: the imagematrix returned by rimage is a 2 (or 3) dimensional array
# if a 3D array last dim is referrng to color channels so
# img[,,1] returns the first channel
# img[,,2] returns the second channel
# as.animage()img[,,1] create the corresponding animage
#
tm.rotationMatrix <- function(theta)
  {
    mat <- array(0, c(2,2));

    mat[1,1] <-  cos(theta);
    mat[1,2] <- -sin(theta);
    mat[2,1] <-  sin(theta);
    mat[2,2] <-  cos(theta);

    mat
  }

tm.scalingMatrix <- function(scalex, scaley)
  {
    if(missing(scaley)) {
      scaley = scalex;
    }
    
    mat <- array(c(scalex, 0, 0, scaley), c(2,2));

    mat
  }

tm.affineMatrix <- function(theta, scalex, scaley, translation = c(0,0))
  {
    rMat <- tm_rotationMatrix(theta)
    sMat <- tm_scalingMatrix(scalex, scaley)
    lMat <- sMat %*% rMat

    
    aMat <- array(0, c(3,3));

    for(j in 1:2) {
      for(i in 1:2) {
        aMat[j,i] <- lMat[j,i]
      }
    }

    aMat[1,3] <- translation[1]
    aMat[2,3] <- translation[2]

    aMat
  }

tm.normalizeFaceImage <- function(image, xleft, yleft, xright, yright, ee = 55)
  {
    theta  <- atan2(yright-yleft, xright-xleft)
    center <- c(-(xright+xleft)*0.5, -(yright+yleft)*0.5)
    scale  <- ee / sqrt((xright-xleft)**2+(yright-yleft)**2)
    aMat   <- tm_affineMatrix(-theta, scale, scale, center)

    print(1.0/scale)

    ia.affine(tm.lanczosSmoothing(image, 1.0 / scale, filler = TRUE), aMat)
  }
