#
# the sRGB color system applies a mapping to all color
# channels that can be well approximated by x**2.2. The
# exact mapping is slightly more complex and has a linear
# part (in the very dark region) and a 2.4 exponent
# afterwards.
#
tm.srgbToLinear <- function(x) {
  if(x <= 0.04045) {
    return(x/12.92)
  } else {
    return(((x+0.055)/1.055)**2.4)
  } 
}
#
# ... mapping linear RGB data to sRGB requires inverse
# gamma mapping ...
#
tm.linearToSrgb <- function(X) {
  if(X <= 0.0031308) {
    return(12.92*X)
  } else {
    return(1.055*(X**0.4166667) - 0.055)
  }
}
