tm.sdf <- function(X, Y = NULL, u = NULL) {
  if(is.null(Y)) {
    # The standard SDF
    #
    if(is.null(u))
      u <- rep(1.0, dim(X)[2])
    
    S <- X %*% solve(t(X) %*% X, u)
  } else {
    # We assume that Y contains more samples
    # than X and switch to least squares SDFs
    if(is.null(u))
      u <- rep(1, dim(Y)[2])
    
    R <- t(X) %*% Y
    S <-  t(matrix(u, nrow=1) %*% pseudoinverse(R) %*% t(X) )
  }
  S
}
