#ifndef	_anicommon_h
#define _anicommon_h 1

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <arrayTools/Array.h>

#include <R.h>
#include <Rdefines.h>
#include <Rinternals.h>

extern void sorting(int *vector);
extern int  statOpCode(const char *opName);

struct opdef {
    char *op_name;	
    int   op_code;	
};

//
//
enum aniOps {NA            =  0,
			 PLUS          =  1,
			 MINUS         =  2,
			 TIMES         =  3,
			 DIVIDE        =  4,
			 MAX           =  5,
			 MIN           =  6,
			 LESS_OR_EQ    =  7,
			 LESS          =  8,
			 GREATER_OR_EQ =  9,
			 GREATER       = 10,
			 EQUAL         = 11,
			 AND           = 12,
			 OR            = 13,
			 XOR           = 14,
			 NOT           = 15,
			 SHIFT_LEFT    = 16,
			 SHIFT_RIGHT   = 17,
             SET           = 18};

#define     ANISLOTS 8

#define     GET_ANIMASK_X(a)   INTEGER(GET_SLOT(a, install("x")))[0]
#define     GET_ANIMASK_Y(a)   INTEGER(GET_SLOT(a, install("y")))[0]
#define     GET_ANIMASK_W(a)   INTEGER(GET_SLOT(a, install("w")))[0]
#define     GET_ANIMASK_H(a)   INTEGER(GET_SLOT(a, install("h")))[0]

#define     GET_ANIMAGE_DI(a)  INTEGER(GET_SLOT(a, install("data")))
#define     GET_ANIMAGE_DR(a)  REAL(GET_SLOT(a, install("data")))
#define     GET_ANIMAGE_X(a)   INTEGER(GET_SLOT(a, install("focus")))[0]
#define     GET_ANIMAGE_Y(a)   INTEGER(GET_SLOT(a, install("focus")))[1]
#define     GET_ANIMAGE_W(a)   INTEGER(GET_DIM(GET_SLOT(a, install("data"))))[1]
#define     GET_ANIMAGE_H(a)   INTEGER(GET_DIM(GET_SLOT(a, install("data"))))[0]
#define     GET_ANIMAGE_OI(a)  INTEGER(GET_SLOT(a, install("outside")))[0]
#define     GET_ANIMAGE_OR(a)  REAL(GET_SLOT(a, install("outside")))[0]

enum aniSlots {DATA     = 0,
			   MODE     = 1,
			   FOCUS    = 2,
			   OUTSIDE  = 3,
			   STORAGE  = 4,
			   DOCUMENT = 5,
			   HISTORY  = 6};

enum aniStorage {ANI_INTEGER = 0,
				 ANI_REAL    = 1};

// support structure to avoid accessing R object slots
//
struct animage {
  union {
	int    *idata;
	double *rdata;
  };
  aniStorage d_store;
  int        x;
  int        y;
  int        w;
  int        h;
  union {
	int     io;
	double  ro;
  };
};

extern void statAni(SEXP ani,
					SEXP *slot);

extern SEXP newAnidata(int w,
					   int h,
					   aniStorage kind);

extern SEXP newAnifocus(int x,
						int y);

extern SEXP newAnimask(int x,
					   int y,
					   int w,
					   int h);

extern SEXP newAnimage(int x,
					   int y,
					   int w,
					   int h,
					   int o);

extern SEXP newAnimage(int    x,
					   int    y,
					   int    w,
					   int    h,
					   double o);

// a set of routines to convert from arrayTools to R 
// and viceversa
//
SEXP               ia2r_bi(ia::array<u_char> &A);
SEXP               ia2r_ii(ia::array<int>    &A);
SEXP               ia2r_fi(ia::array<float>  &A);
SEXP               ia2r_di(ia::array<double> &A);
SEXP               ia2r_dr(ia::array<double> &A);
ia::array<int>    &r2ia_ii(SEXP               animage);
ia::array<double> &r2ia_rd(SEXP               animage);


extern double min(double, double);
extern double max(double, double);
extern int    min(int,    int);
extern int    max(int,    int);


#endif
