#ifndef	_global_h
#define _global_h 1

/*
 * (c) 1993,1994,1995,1996 by ITC-IRST
 *
 */


#include <arrayTools/namespace_header.h>


#ifndef TRUE
#define TRUE	(1==1)
#endif

#ifndef FALSE
#define FALSE	(1==0)
#endif


namespace _ARRAYTOOLS_NAMESPACE
{
  template<class T>  
    inline T MIN(const T x, const T y) 
    { 
      return ( ( (x) < (y) ) ? (x) : (y) ); 
    }


  template<class T>  
    inline T MAX(const T x, const T y) 
    { 
      return ( ( (x) > (y) ) ? (x) : (y) );
    }

  template<class T>
    inline T SQUARE(const T x)
    {
      return x*x;
    }

  template<class T>
    inline T SQUARE4(const T x)
    {
      return x*x*x*x;
    }

  template<class T>
    inline T ABS(const T x)
    {
      return ( ( (x) >= 0)? (x): -(x) );
    }

  template<class A, class B, class C>
    inline int SECTOR(const A val, const B min, const C max)
    {
      return (((val) < (min))? -1: (((val) > (max))? 1: 0));
    }

  template<class T>
    inline T RANGE(const T v, const T min, const T max)
    {
      return ( ((v) <= (min)) ? (min) : ( ( (v) >= (max) ) ? (max) : (v) ));
    }


  template <class T>
    inline void SWAP(T & a, T & b) 
    {
      T temp = a;
      a      = b;
      b      = temp;
    }


  template<class T> inline bool SAMESIGNS(const T a, const T b)
  {
    if ((a > 0) && (b < 0)) return false;
    if ((a < 0) && (b > 0)) return false;
    return true;
  }
  
  template<class T, class U> inline T SIGNMULT(const T a, const U b) 
    {
      return ((b) >= 0.0 ? (((a) >= 0)? (a): -(a)) : -(((a) >= 0)? (a): -(a)));
    }

  template<class T, class U> inline bool EQUAL(const T a, const U b, double threshold = 1.0e-20)
    {
      return (((double)(b)-(threshold) <= (double)(a)) && ((double)(a) <= (double)(b)+(threshold)));
    }


}

#define MEMUNITSIZE 8
#if !defined(HAVE_BOOLEAN)
typedef int boolean;
#endif
#if defined(_WIN32)
typedef struct _memUnit {char  bytes[MEMUNITSIZE];} memUnit;
#else
typedef struct _memUnit {char  bytes[MEMUNITSIZE];} memUnit  __attribute__((aligned (8)));
#endif

#endif
