/*
 * (c) 1993,1994,1995,1996 by ITC-IRST
 *
 */

/*
 * Definitions for AnImAl interface
 *
 */


#ifndef IO_HEADS_H
#define IO_HEADS_H

#include <arrayTools/namespace_header.h>


namespace _ARRAYTOOLS_NAMESPACE
{

typedef	    struct _animal_header {
			    int    MAGIC;
			    int    rows;
			    int    cols;
			    int    type;
			    int    focusx;
			    int    focusy;
			    int    outside;
			    int    flag;
			} animal_header;


/* ANIMAL magic numbers */

#define lIMAGE	    		12081961
#define lARRAY	    		13081962

/* extended ANIMAL array types */

enum AnImAl_types 
 {
   anCHAR = 1, anUCHAR = 2, anSHORT = 3, anINT = 5, anFLOAT = 9, anDOUBLE = 10
   };


template<class T> inline int AnimalType()                 { return 0; }
template<>        inline int AnimalType<char>()           { return anCHAR; }
template<>        inline int AnimalType<unsigned char>()  { return anUCHAR; }
template<>        inline int AnimalType<short>()          { return anSHORT; }
template<>        inline int AnimalType<int>()            { return anINT; }
template<>        inline int AnimalType<float>()          { return anFLOAT; }
template<>        inline int AnimalType<double>()         { return anDOUBLE; }




typedef  unsigned char     u_char;
typedef  unsigned short    u_short;
typedef  unsigned int      u_int;
typedef  unsigned long     u_long;
typedef  unsigned short    ushort;	/* System V compatibility */
typedef  unsigned int      uint;	/* System V compatibility */

}

#endif
