#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <arrayTools/aniCommon.h>
#include <arrayTools/EuclideanTransform.h>

extern "C"  {

  SEXP aniDistanceTransform(SEXP animage_1) // Must be an animage object
  {
	SEXP              ani_r;
	ia::array<int>    A = r2ia_ii(animage_1);
	ia::array<int>    X, Y;
	ia::array<double> D;
	
	SignedEuclideanDistanceTransform(A, X, Y, D);
	
	PROTECT(ani_r = NEW_LIST(3));

	SET_ELEMENT(ani_r, 0, ia2r_ii(X));
	SET_ELEMENT(ani_r, 1, ia2r_ii(Y));
	SET_ELEMENT(ani_r, 2, ia2r_dr(D));

	UNPROTECT(1);

	return(ani_r);
  }
}
