#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <arrayTools/aniCommon.h>
#include <arrayTools/RobustEstimates.h>

extern "C"  {

  SEXP tmRobustEstimates(SEXP r_X,
						  SEXP r_mode) // Must be an array
  {
	SEXP        ani_r;
	const char *mode = CHAR(STRING_ELT(r_mode, 0));

	// Get dimensions of data array
	//
	int     cols = INTEGER(GET_DIM(r_X))[1];
	int     rows = INTEGER(GET_DIM(r_X))[0];
	double *X    = REAL(r_X);
	
	// return an array whose 
	//    first row is location
	//    second row is scale
	//
	PROTECT(ani_r      = newAnidata(cols, 2, ANI_REAL));
	double *R          = REAL(ani_r);

	ia::vector<double> buffer(rows);
	double             pos_return;
	double             scale_return;

	for(int i = 0; i < cols; i++)
	  {
		for(int j = 0; j < rows; j++)
		  buffer[j] = *X++;
		
		PositionAndScale(buffer, 
						 mode[0], 
						 &pos_return,
						 &scale_return,
						 1,
						 1);
		
		*R++ = pos_return;
		*R++ = scale_return;
	  }

	UNPROTECT(1);

	return(ani_r);
  }
}
